# ArrayGetters

*External library for array getters to save bytecode size in facet libraries*

## getTraders

```solidity
function getTraders(uint32 _offset, uint32 _limit) public view returns (address[])
```

*Check ITradingStorageUtils interface for documentation*

## getTrades

```solidity
function getTrades(address _trader) public view returns (struct ITradingStorage.Trade[])
```

*Check ITradingStorageUtils interface for documentation*

## getAllTradesForTraders

```solidity
function getAllTradesForTraders(address[] _traders, uint256 _offset, uint256 _limit) public view returns (struct ITradingStorage.Trade[])
```

*Check ITradingStorageUtils interface for documentation*

## getAllTrades

```solidity
function getAllTrades(uint256 _offset, uint256 _limit) external view returns (struct ITradingStorage.Trade[])
```

*Check ITradingStorageUtils interface for documentation*

## getTradeInfos

```solidity
function getTradeInfos(address _trader) public view returns (struct ITradingStorage.TradeInfo[])
```

*Check ITradingStorageUtils interface for documentation*

## getAllTradeInfosForTraders

```solidity
function getAllTradeInfosForTraders(address[] _traders, uint256 _offset, uint256 _limit) public view returns (struct ITradingStorage.TradeInfo[])
```

*Check ITradingStorageUtils interface for documentation*

## getAllTradeInfos

```solidity
function getAllTradeInfos(uint256 _offset, uint256 _limit) external view returns (struct ITradingStorage.TradeInfo[])
```

*Check ITradingStorageUtils interface for documentation*

## getPendingOrders

```solidity
function getPendingOrders(address _trader) public view returns (struct ITradingStorage.PendingOrder[])
```

*Check ITradingStorageUtils interface for documentation*

## getAllPendingOrdersForTraders

```solidity
function getAllPendingOrdersForTraders(address[] _traders, uint256 _offset, uint256 _limit) public view returns (struct ITradingStorage.PendingOrder[])
```

*Check ITradingStorageUtils interface for documentation*

## getAllPendingOrders

```solidity
function getAllPendingOrders(uint256 _offset, uint256 _limit) external view returns (struct ITradingStorage.PendingOrder[])
```

*Check ITradingStorageUtils interface for documentation*

## getTradesLiquidationParams

```solidity
function getTradesLiquidationParams(address _trader) public view returns (struct IPairsStorage.GroupLiquidationParams[])
```

*Check ITradingStorageUtils interface for documentation*

## getAllTradesLiquidationParamsForTraders

```solidity
function getAllTradesLiquidationParamsForTraders(address[] _traders, uint256 _offset, uint256 _limit) public view returns (struct IPairsStorage.GroupLiquidationParams[])
```

*Check ITradingStorageUtils interface for documentation*

## getAllTradesLiquidationParams

```solidity
function getAllTradesLiquidationParams(uint256 _offset, uint256 _limit) external view returns (struct IPairsStorage.GroupLiquidationParams[])
```

*Check ITradingStorageUtils interface for documentation*

## getCountersForTraders

```solidity
function getCountersForTraders(address[] _traders, enum ITradingStorage.CounterType _counterType) external view returns (struct ITradingStorage.Counter[])
```

*Check ITradingStorageUtils interface for documentation*


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.gains.trade/developer/technical-reference/contracts/libraries/arraygetters.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
